*This do file generates table: "Effect of DRT on bank profits"

set more off
clear
set matsize 500

cd E:\papers\sujataanddilip\bankbranches\sv
 

use bankleveldata.dta, clear
egen banktag=tag(bankid)
xtile size=banknrab92 if banktag==1
sort bankid size
replace size=size[_n-1] if size==.
label var size "bank size in terms of 1992 total branches"

drop if fyear<1992

eststo clear

foreach d in profits pbdpta {
foreach y of varlist `d' {
qui: eststo: areg `y' drtexposure_ce1 ydum*, absorb(bankid) robust cluster(bankid)
qui: eststo: areg `y' drtexposure_cf1 ydum*, absorb(bankid) robust cluster(bankid)
bys size: eststo: areg `y' drtexposure_ce1 ydum*, absorb(bankid) robust cluster(bankid)
bys size: eststo: areg `y' drtexposure_cf1 ydum*, absorb(bankid) robust cluster(bankid)
}
}

foreach d in profits pbdpta {
foreach y of varlist `d'_loans `d'_branche `d'_branchf `d'_loans92 `d'_branche92 `d'_branchf92 {
qui: eststo: areg `y' drtexposure_ce2 ydum*, absorb(bankid) robust cluster(bankid)
qui: eststo: areg `y' drtexposure_cf2 ydum*, absorb(bankid) robust cluster(bankid)
bys size: eststo: areg `y' drtexposure_ce2 ydum*, absorb(bankid) robust cluster(bankid)
bys size: eststo: areg `y' drtexposure_cf2 ydum*, absorb(bankid) robust cluster(bankid)
}
}
cd E:\papers\sujataanddilip\prowessnew\revisionECMA

esttab * using bankprofits_dec2010.csv, replace label star(* 0.10 ** 0.05 *** 0.01) nonumbers drop(ydum*) title(Effect of DRT on bank profits -- Dec2010.)  /*
   */ addnote("Standard errors are clustered at the bank level. All regressions include year fe.")/*
 */postfoot(\multicolumn{@span}{l}{\ {\footnotesize  Standard errors cluster at state level.  \textit{t} statistics in parentheses. \sym{*} \(p<0.10\), \sym{**} \(p<0.05\), \sym{***} \(p<0.01\)} } \\ \multicolumn{@span}{l}{\ \input{bankprofits.txt} }\end{tabular}\end{table})  
