//This do file will create the data set used in tablesbankdata.do.
//It works on the private bank data set.


**working with newdata3.dta created by newdata.do
clear
cap log close
log using genbankdata.log, append

set mem 1250m
set more off

**First use the data set that has the project state and project purpose
***need to merge with a file which has the project state for each sancid
***also use it for the purpose_desc (== project type)
use <INSERT NAME OF FILE WITH SANCTIONS DATA>, clear

gen projcluster=1 if state_desc=="WEST BENGAL" | state_desc=="ANDAMAN & NICOBAR ISLANDS"
replace projcluster=2 if state_desc=="DELHI"
replace projcluster=3 if state_desc=="RAJASTHAN" | state_desc=="HIMACHAL PRADESH" | state_desc=="HARYANA" | state_desc=="PUNJAB" | state_desc=="CHANDIGARH"
replace projcluster=4 if state_desc=="KARNATAKA" | state_desc=="ANDHRA PRADESH"
replace projcluster=5 if state_desc=="GUJARAT" | state_desc=="DADRA & NAGAR HAVELI" | state_desc=="DAMAN & DIU"
replace projcluster=6 if state_desc=="TAMIL NADU" | state_desc=="KERALA" | state_desc=="PONDICHERRY"
replace projcluster=7 if state_desc=="ASSAM" | state_desc=="MANIPUR" | state_desc=="MEGHALAYA" | state_desc=="NAGALAND" | state_desc=="TRIPURA"
replace projcluster=8 if state_desc=="BIHAR" | state_desc=="JHARKHAND" | state_desc=="ORISSA"
replace projcluster=9 if state_desc=="MADHYA PRADESH" | state_desc=="CHHATTISGARH" | state_desc=="UTTAR PRADESH" | state_desc=="UTTARANCHAL"
replace projcluster=10 if state_desc=="GOA" | state_desc=="MAHARASHTRA"
replace projcluster=11 if state_desc=="SIKKIM"
replace projcluster=12 if state_desc=="LAKSHWADEEP"

label def projcluster 1 "WBe" 2 "Del" 3 "Raj/HPr/Har/Pun" 4 "Kar/APr" 5 "Guj" 6 "TNa/Ker" 7 "NorthEast" 8 "Bih/Ori" 9 "MPr/UPr" 10 "Mah/Goa" 11 "Sik" 12 "Lak", add
label values projcluster projcluster

encode purpose_desc, gen(projpurpose)
label values projpurpose projpurpose

drop sancid
gen long sancid=(bid*1000)+sancsr
format sancid %17.0g
bys sancid: gen n=_n

collapse (count)n (mean)projcluster=projcluster (sd)sddrt=projcluster (mean)projpurpose, by(sancid)
summ projcluster sddrt projpurpose n

sort sancid
save projectstate, replace

**now use disbursement data
use <NAME OF FILE WITH DISBURSEMENT DATA>

sort sancid
merge sancid using projectstate
tab _merge

*only want to keep loans in INR
keep if ddccy==7

count if ddamt==.
*no ddamts with missing values.

count if dddt==.
*no dddts with missing values.

gen ddtq=qofd(dddt)
gen ddt=yofd(dddt)

gen durdays=matdt-dddt
drop if durdays<0
summ durdays

gen migratedate=mdy(9,15,2000)
gen startdate8=mdy(1,1,1992)
gen startdate4=mdy(1,1,1996)

***Include commands to keep only disbursements of type (i) (of duration of 8 years and longer) and then of type (ii) (of duration of 4 years and longer) as described above in comments.

**migratedate-startdate8 is 8 years and 9.5 months, migratedate-startdate4 is 4 years and 9.5 months
**tag=8 if maturity duration is greater than or equal to 8yrs9.5mths; tag=4 if maturity duration is greater than or equal to 4yrs 9.5mths
gen tag8=(durdays>=migratedate-startdate8)
gen tag4=(durdays>=migratedate-startdate4)
tab tag8 tag4

drop if tag8==0 & tag4==0
keep bid sancid ddid dd_no ddtq ddt durdays projcluster ddamt ddintrate ddccy tag4 tag8 

keep if dd_no==1
drop if projcluster==.
tab ddtq

compress
count

*drop negative ddamts
drop if ddamt<0

rename ddamt creditrcvd_disb 
rename ddintrate intrate_disb
count

*only keep observations on or after 1981q1.
drop if ddtq<84

replace creditrcvd_disb=0 if creditrcvd_disb==.
sort bid ddid projcluster ddtq
save e:\budesktopbackup\data\drtge\creditrcvd_disb, replace

***now include other variables: industry, opsgroup, borrower's location

use <NAME OF DATA SET WITH INDUSTRY, OPERATIONS GROUP, BORROWER'S ADDRESS>, clear
keep bid clstate industry opsgroup
decode clstate, gen(state_desc)
gen borrcluster=1 if state_desc=="WEST BENGAL" | state_desc=="ANDAMAN & NICOBAR ISLANDS"
replace borrcluster=2 if state_desc=="DELHI"
replace borrcluster=3 if state_desc=="RAJASTHAN" | state_desc=="HIMACHAL PRADESH" | state_desc=="HARYANA" | state_desc=="PUNJAB" | state_desc=="CHANDIGARH"
replace borrcluster=4 if state_desc=="KARNATAKA" | state_desc=="ANDHRA PRADESH"
replace borrcluster=5 if state_desc=="GUJARAT" | state_desc=="DADRA & NAGAR HAVELI" | state_desc=="DAMAN & DIU"
replace borrcluster=6 if state_desc=="TAMIL NADU" | state_desc=="KERALA" | state_desc=="PONDICHERRY"
replace borrcluster=7 if state_desc=="ASSAM" | state_desc=="MANIPUR" | state_desc=="MEGHALAYA" | state_desc=="NAGALAND" | state_desc=="TRIPURA"
replace borrcluster=8 if state_desc=="BIHAR" | state_desc=="JHARKHAND" | state_desc=="ORISSA"
replace borrcluster=9 if state_desc=="MADHYA PRADESH" | state_desc=="CHHATTISGARH" | state_desc=="UTTAR PRADESH" | state_desc=="UTTARANCHAL"
replace borrcluster=10 if state_desc=="GOA" | state_desc=="MAHARASHTRA"
replace borrcluster=11 if state_desc=="SIKKIM"
replace borrcluster=12 if state_desc=="LAKSHWADEEP"
replace borrcluster=. if state_desc==""
replace borrcluster=. if state_desc=="NOT AVAILABLE"

label def statecluster 1 "WBe" 2 "Del" 3 "Raj/HPr/Har/Pun" 4 "Kar/APr" 5 "Guj" 6 "TNa/Ker" 7 "NorthEast" 8 "Bih/Ori" 9 "MPr/UPr" 10 "Mah/Goa" 11 "Sik" 12 "Lak", add
label values borrcluster statecluster

drop clstate 
encode state_desc, gen(clstate)

sort bid
save clientdata, replace

**assets, income, sales, debt-equity ratio

use <NAME OF DATA SET WITH ASSETS>, clear
*if a=C then value is in crores, if a=L or missing then value is in lakhs
replace faland=faland/100 if a=="L" | a==""
replace famach=famach/100 if a=="L" | a==""
replace fabuild=fabuild/100 if a=="L" | a==""
replace faother=faother/100 if a=="L" | a==""
replace dep=dep/100 if a=="L" | a==""
replace sheqty=sheqty/100 if a=="L" | a==""
replace rescap=rescap/100 if a=="L" | a==""
replace resgen=resgen/100 if a=="L" | a==""
replace resspecific=resspecific/100 if a=="L" | a==""
replace resint1=resint1/100 if a=="L" | a==""
replace nvl=nvl/100 if a=="L" | a==""
 
gen assets=faland+famach+fabuild+faother
*keep assets rescap sheqty t a
 *gen year=yofd(dofq(tq))
  rename year t
sort bid t
drop if a=="Y"
 
**keep only latest observation per firm before 1992 and first observation if asset is missing under the first rule
 
drop if assets==. 
 
sort bid enddate
gen earlyassets=1 if enddate<=mdy(03,31,1991)
replace earlyassets=0 if earlyassets==.
 
gsort bid -enddate earlyassets
 
duplicates drop bid if earlyassets==1, force
gsort bid enddate 
duplicates drop bid, force 
 
drop if t<1981
compress
 
sort bid t
rename t yearofasset
 
save balancefirstobs, replace


**now profit
use <NAME OF DATA SET WITH PROFIT & LOSS DATA>, clear
*if a=C then value is in crores, if a=L or missing then value is in lakhs
replace gsales=gsales/100 if a=="L" | a==""
replace netsales=netsales/100 if a=="L" | a==""
replace relinc=relinc/100 if a=="L" | a==""
replace totinc=totinc/100 if a=="L" | a==""
replace rm=rm/100 if a=="L" | a==""
replace salary=salary/100 if a=="L" | a==""
replace totcost=totcost/100 if a=="L" | a==""
replace pbild=pbild/100 if a=="L" | a==""
replace interest=interest/100 if a=="L" | a==""
replace lease=lease/100 if a=="L" | a==""
replace dep=dep/100 if a=="L" | a==""
replace opprofit=opprofit/100 if a=="L" | a==""
replace unrelinc=unrelinc/100 if a=="L" | a==""
replace tax=tax/100 if a=="L" | a==""
replace netprofit=netprofit/100 if a=="L" | a==""
replace prefdiv=prefdiv/100 if a=="L" | a==""
replace reserves=reserves/100 if a=="L" | a==""
replace expsales=expsales/100 if a=="L" | a==""
replace rmprcnt=rmprcnt/100 if a=="L" | a==""

drop if a=="Y"
rename year t

**keep only 1 observation per bid per year -- in some (few) cases there are more than 1 observation
sort bid enddate
duplicates drop bid t, force
*this will keep the earliest observation from each year

drop if t<1981
compress
sort bid t
save e:\budesktopbackup\data\drtge\profit, replace

**now ratio
use <NAME OF DATA SET WITH FINANCIAL RATIOS>, clear

replace profr6=profr6/100 if a=="L" | a==""
replace capr3=capr3/100 if a=="L" | a==""

drop if a=="Y"
rename year t

**keep only 1 observation per bid per year -- in some (few) cases there are more than 1 observation
sort bid enddate
duplicates drop bid t, force
*this will keep the earliest observation from each year

drop if t<1981
compress
sort bid t
save e:\budesktopbackup\data\drtge\ratio, replace

***now merge everything
clear
set mem 1000m

use creditrcvd_disb, clear
count
compress

gen t=ddt
sort bid t

merge bid using balancefirstobs
tab _merge
drop _merge sheqty rescap resgen resspecific resint1 nvl faland famach fabuild faother
sort bid t
compress

merge bid t using profit
tab _merge
drop _merge relinc rm salary totcost expsales prefdiv reserves rmprcnt
sort bid t
compress

sort bid
merge bid using clientdata
tab _merge
drop _merge
compress

label values projcluster statecluster
sort bid projcluster ddtq

count if bid==.
count if ddid==.
count if ddtq==.
drop if ddtq==.
*these are observations where we know the borrower's financial information but nothing else

compress

save newdata3_forintrate, replace

***Now extract the data needed & work with them.
use creditrcvd_disb intrate_disb durdays enddate yearofasset assets industry borrcluster clstate bid ddid t ddtq tag4 tag8 if t<=2002 using newdata3_forintrate.dta

*these are data at the ddid-tq level
*drop data after 2002 because 2003 data likely to be incomplete since data collected in Summer 2003, and data after that only contain scheduled invoices but no actual information about what happened.

***Include only disbursements that took place after or in 1992. 
gen tag92=(t>=1992)
gen tag96=(t>=1996)

tab tag92 tag96
drop if tag92==0 & tag96==0

count

replace clstate=. if clstate==17
decode clstate, gen(CLstate)
label drop clstate
encode CLstate, gen(newclstate)

gen bdrtdts=mdy(4,27,1994) if borrcluster==1
replace bdrtdts=mdy(7,5,1994) if borrcluster==2
replace bdrtdts=mdy(8,30,1994) if borrcluster==3
replace bdrtdts=mdy(11,30,1994) if borrcluster==4
replace bdrtdts=mdy(12,21,1994) if borrcluster==5
replace bdrtdts=mdy(11,4,1996) if borrcluster==6
replace bdrtdts=mdy(1,7,1997) if borrcluster==7
replace bdrtdts=mdy(1,24,1997) if borrcluster==8
replace bdrtdts=mdy(4,7,1998) if borrcluster==9
replace bdrtdts=mdy(7,16,1999) if borrcluster==10
replace bdrtdts=mdy(12,5,1997) if borrcluster==11| borrcluster==12

gen bdrtdtq=qofd(bdrtdts)
gen bdrt=(ddtq>=bdrtdtq)
format bdrtdts %d
format bdrtdtq %tq
drop bdrtdts bdrtdtq

gen assets2=assets^2

replace creditrcvd_disb=creditrcvd/10000000
note creditrcvd_disb: "Credit received, crores"

gen drtdts1=mdy(4,27,1994)
gen drtdts2=mdy(7,5,1994)
gen drtdts3=mdy(8,30,1994)
gen drtdts4=mdy(11,30,1994)
gen drtdts5=mdy(12,21,1994)
gen drtdts6=mdy(11,4,1996)
gen drtdts7=mdy(1,7,1997)
gen drtdts8=mdy(1,24,1997)
gen drtdts9=mdy(4,7,1998)
gen drtdts10=mdy(7,16,1999)
gen drtdts11=mdy(12,5,1997)
gen drtdts12=mdy(12,5,1997)

gen drtdtq1=qofd(drtdts1)
gen drtdtq2=qofd(drtdts2)
gen drtdtq3=qofd(drtdts3)
gen drtdtq4=qofd(drtdts4)
gen drtdtq5=qofd(drtdts5)
gen drtdtq6=qofd(drtdts6)
gen drtdtq7=qofd(drtdts7)
gen drtdtq8=qofd(drtdts8)
gen drtdtq9=qofd(drtdts9)
gen drtdtq10=qofd(drtdts10)
gen drtdtq11=qofd(drtdts11)
gen drtdtq12=qofd(drtdts12)

gen drt1=(ddtq>=drtdtq1)
replace drt1=. if ddtq==.
gen drt2=(ddtq>=drtdtq2)
replace drt2=. if ddtq==.
gen drt3=(ddtq>=drtdtq3)
replace drt3=. if ddtq==.
gen drt4=(ddtq>=drtdtq4)
replace drt4=. if ddtq==.
gen drt5=(ddtq>=drtdtq5)
replace drt5=. if ddtq==.
gen drt6=(ddtq>=drtdtq6)
replace drt6=. if ddtq==.
gen drt7=(ddtq>=drtdtq7)
replace drt7=. if ddtq==.
gen drt8=(ddtq>=drtdtq8)
replace drt8=. if ddtq==.
gen drt9=(ddtq>=drtdtq9)
replace drt9=. if ddtq==.
gen drt10=(ddtq>=drtdtq10)
replace drt10=. if ddtq==.
gen drt11=(ddtq>=drtdtq11)
replace drt11=. if ddtq==.
gen drt12=(ddtq>=drtdtq12)
replace drt12=. if ddtq==.

gen drtall=drt1+drt2+drt3+drt4+drt5+drt6+drt7+drt8+drt9+drt10+drt11+drt12
drop drtdtq1 drtdtq2 drtdtq3 drtdtq4 drtdtq5 drtdtq6 drtdtq7 drtdtq8 drtdtq9 drtdtq10 drtdtq11 drtdtq12
drop drtdts1 drtdts2 drtdts3 drtdts4 drtdts5 drtdts6 drtdts7 drtdts8 drtdts9 drtdts10 drtdts11 drtdts12
label var drtall "Sum(DRT_j)"

gen drtown=.

forvalues x=1/12 {
    display "cluster=`x'"
    replace drtown=drt`x' if borrcluster==`x'
    }
replace drtown=0 if drtown==.

label var drtown "DRT_i"

count
sort ddid ddtq
save newdataborr1_disb, replace


**************************************************************************
**************************************************************************
//Now create the data set needed to analyze repayment in Table XVII.

clear
clear matrix

**First use the data set that has the project state and project purpose
***need to merge with a file which has the project state for each sancid
***also use it for the purpose_desc (== project type)
use <INSERT NAME OF FILE WITH SANCTIONS DATA>, clear

gen projcluster=1 if state_desc=="WEST BENGAL" | state_desc=="ANDAMAN & NICOBAR ISLANDS"
replace projcluster=2 if state_desc=="DELHI"
replace projcluster=3 if state_desc=="RAJASTHAN" | state_desc=="HIMACHAL PRADESH" | state_desc=="HARYANA" | state_desc=="PUNJAB" | state_desc=="CHANDIGARH"
replace projcluster=4 if state_desc=="KARNATAKA" | state_desc=="ANDHRA PRADESH"
replace projcluster=5 if state_desc=="GUJARAT" | state_desc=="DADRA & NAGAR HAVELI" | state_desc=="DAMAN & DIU"
replace projcluster=6 if state_desc=="TAMIL NADU" | state_desc=="KERALA" | state_desc=="PONDICHERRY"
replace projcluster=7 if state_desc=="ASSAM" | state_desc=="MANIPUR" | state_desc=="MEGHALAYA" | state_desc=="NAGALAND" | state_desc=="TRIPURA"
replace projcluster=8 if state_desc=="BIHAR" | state_desc=="JHARKHAND" | state_desc=="ORISSA"
replace projcluster=9 if state_desc=="MADHYA PRADESH" | state_desc=="CHHATTISGARH" | state_desc=="UTTAR PRADESH" | state_desc=="UTTARANCHAL"
replace projcluster=10 if state_desc=="GOA" | state_desc=="MAHARASHTRA"
replace projcluster=11 if state_desc=="SIKKIM"
replace projcluster=12 if state_desc=="LAKSHWADEEP"

label def projcluster 1 "WBe" 2 "Del" 3 "Raj/HPr/Har/Pun" 4 "Kar/APr" 5 "Guj" 6 "TNa/Ker" 7 "NorthEast" 8 "Bih/Ori" 9 "MPr/UPr" 10 "Mah/Goa" 11 "Sik" 12 "Lak", add
label values projcluster projcluster

encode purpose_desc, gen(projpurpose)
label values projpurpose projpurpose

drop sancid
gen long sancid=(bid*1000)+sancsr
format sancid %17.0g
bys sancid: gen n=_n

collapse (count)n (mean)projcluster=projcluster (sd)sddrt=projcluster (mean)projpurpose, by(sancid)
summ projcluster sddrt projpurpose n

sort sancid
save projectstate, replace

**now use disbursement data 
use <NAME OF FILE WITH DISBURSEMENT DATA>
sort sancid
merge sancid using projectstate
tab _merge

*only want to keep loans in INR
keep if ddccy==7

count if ddamt==.
*no ddamts with missing values.

count if dddt==.
*no dddts with missing values.

gen ddtq=qofd(dddt)
gen ddt=yofd(dddt)

gen durdays=matdt-dddt
drop if durdays<0

keep bid sancid ddid dd_no ddtq ddt durdays projcluster ddamt ddintrate ddccy

keep if dd_no==1
drop if projcluster==.
tab ddtq

compress
count

*drop negative ddamts
drop if ddamt<0

*we want sum of credit received (unweighted), and weighted average of interest rate, duration, etc. weights=creditrcvd.
*but collapse command will apply weights to all statistics so run two separate collapse commands and then merge

save interim1, replace

collapse (sum)creditrcvd=ddamt, by(bid projcluster ddtq)
sort bid projcluster ddtq
save interim2, replace

use interim1, clear
collapse (mean)intrate=ddintrate avgdur=durdays (min)mindur=durdays (max)maxdur=durdays [pw=ddamt], by(bid projcluster ddtq)
sort bid projcluster ddtq

merge bid projcluster ddtq using interim2
tab _merge
drop _merge

count

*only keep observations on or after 1981q1.
drop if ddtq<84

replace creditrcvd=0 if creditrcvd==.
rename ddtq tq
sort bid projcluster tq
save creditrcvd, replace

erase interim1.dta
erase interim2.dta

****Now working on invoice-repayment data to get repayment information
use <NAME OF DATA SET WITH INVOICE-REPAYMENT INFORMATION>, clear

*First, to correct for attrition, need to drop all ddid's whose last invoice date was after the date of migration.
*So first identify those ddids that should be kept.

collapse (max) tq, by(ddid)
gen migratedt=mdy(9,15,2000)
gen tqdt=dofq(tq)
*keeping only those ddids whose last invoice date is before the date of migration.
keep if migratedt-90<tqdt
*lose lots of ddids
drop tq
sort ddid
save migratemaster, replace


****Now the repayment behavior in each quarter
use <NAME OF DATA SET WITH INVOICE-REPAYMENT INFORMATION>, clear

*first correct for attrition by keeping only those ddid's whose last invoice date is after migration date
sort ddid
merge ddid using migratemaster
tab _merge
keep if _merge==3
drop _merge
save irwidenoattr, replace

*drop observations before 1981
drop if duetq<84
sort sancid
save repaymentinterim1, replace

***ONLY want repayment behavior of sanctions that were given before the DRT Act date, i.e. 24th June 1993.
*to get sanction date, merge this dataset with data set that has sanction/loan data.
use <NAME OF DATA SET WITH SANCTIONS>, clear

egen tag=tag(sancid)
keep if tag==1
keep sancdt sancid
sort sancid
merge sancid using repaymentinterim1

tab _merge
keep if _merge==3

*now use allpin180
**allpin180 takes value 1 if all invoices in this quarter on this ddid were paid within 180 days. it takes value 0 otherwise.
**but only use allpin180 for those sanctions that were given before June 24, 1993 (i.e. the DRT Act date).

count
keep if sancdt<mdy(6,24,1993)
count

collapse (min)minallpin180=allpin180 (mean)avgallpin180=allpin180 (mean)bid, by(sancid tq)
*These are two binary variables for repayment behavior per sanction per quarter. need to preserve sancid information so that we can assign a project state.
*minallpin180: takes value 0 if even one invoice on this sanction in this quarter was not paid on time, only takes value 1 if *all* *were repaid on time.
*meanallpin180: the average number of times that all invoices were paid on time.

count
compress
sort sancid tq
save repayaccounts_new, replace

***now merge repayaccounts_new with projectstate data
use repayaccounts_new, clear
sort sancid
merge sancid using projectstate
tab _merge
drop n

keep if _merge==3
drop if projcluster==.

**Now need to create a borrower-state-tq level dataset, so collapse to that level -- basically average/min of the repayment
**variable within a borrower-state-tq.

count
collapse (min)minallpin180 (mean)avgallpin180, by(bid projcluster tq)
count

move bid tq
sort bid projcluster tq
save repay_new, replace


***now include other variables
**industry, opsgroup, borrower's location

use <DATA SET WITH INDUSTRY, OPERATIONS GROUPS, BORROWER'S ADDRESS>, clear
keep bid clstate industry opsgroup
decode clstate, gen(state_desc)
gen borrcluster=1 if state_desc=="WEST BENGAL" | state_desc=="ANDAMAN & NICOBAR ISLANDS"
replace borrcluster=2 if state_desc=="DELHI"
replace borrcluster=3 if state_desc=="RAJASTHAN" | state_desc=="HIMACHAL PRADESH" | state_desc=="HARYANA" | state_desc=="PUNJAB" | state_desc=="CHANDIGARH"
replace borrcluster=4 if state_desc=="KARNATAKA" | state_desc=="ANDHRA PRADESH"
replace borrcluster=5 if state_desc=="GUJARAT" | state_desc=="DADRA & NAGAR HAVELI" | state_desc=="DAMAN & DIU"
replace borrcluster=6 if state_desc=="TAMIL NADU" | state_desc=="KERALA" | state_desc=="PONDICHERRY"
replace borrcluster=7 if state_desc=="ASSAM" | state_desc=="MANIPUR" | state_desc=="MEGHALAYA" | state_desc=="NAGALAND" | state_desc=="TRIPURA"
replace borrcluster=8 if state_desc=="BIHAR" | state_desc=="JHARKHAND" | state_desc=="ORISSA"
replace borrcluster=9 if state_desc=="MADHYA PRADESH" | state_desc=="CHHATTISGARH" | state_desc=="UTTAR PRADESH" | state_desc=="UTTARANCHAL"
replace borrcluster=10 if state_desc=="GOA" | state_desc=="MAHARASHTRA"
replace borrcluster=11 if state_desc=="SIKKIM"
replace borrcluster=12 if state_desc=="LAKSHWADEEP"
replace borrcluster=. if state_desc==""
replace borrcluster=. if state_desc=="NOT AVAILABLE"

label def statecluster 1 "WBe" 2 "Del" 3 "Raj/HPr/Har/Pun" 4 "Kar/APr" 5 "Guj" 6 "TNa/Ker" 7 "NorthEast" 8 "Bih/Ori" 9 "MPr/UPr" 10 "Mah/Goa" 11 "Sik" 12 "Lak", add
label values borrcluster statecluster

drop clstate state_desc

sort bid
save clientdata, replace

**assets, income, sales, debt-equity ratio 

**now balance
use <NAME OF DATA SET WITH BALANCE SHEET INFO>, clear
*if a=C then value is in crores, if a=L or missing then value is in lakhs
replace faland=faland/100 if a=="L" | a==""
replace famach=famach/100 if a=="L" | a==""
replace fabuild=fabuild/100 if a=="L" | a==""
replace faother=faother/100 if a=="L" | a==""
replace dep=dep/100 if a=="L" | a==""
replace sheqty=sheqty/100 if a=="L" | a==""
replace rescap=rescap/100 if a=="L" | a==""
replace resgen=resgen/100 if a=="L" | a==""
replace resspecific=resspecific/100 if a=="L" | a==""
replace resint1=resint1/100 if a=="L" | a==""
replace nvl=nvl/100 if a=="L" | a==""

egen assets=rowtotal(faland famach fabuild faother)
gen x=faland+famach+fabuild+faother
*keep assets rescap sheqty t a
 *gen year=yofd(dofq(tq))
  rename year t
sort bid t
drop if a=="Y"
 
**keep only latest observation per firm before 1992 and first observation if asset is missing under the first rule
 
drop if assets==. 
 
sort bid enddate
gen earlyassets=1 if enddate<=mdy(03,31,1991)
replace earlyassets=0 if earlyassets==.
 
gsort bid -enddate earlyassets
 
duplicates drop bid if earlyassets==1, force
gsort bid enddate 
duplicates drop bid, force 
 
drop if t<1981
compress
 
sort bid t
rename t yearofasset
 
save balancefirstobs, replace

**now profit
use <NAME OF DATA SET WITH PROFIT & LOSS DATA>, clear
*if a=C then value is in crores, if a=L or missing then value is in lakhs
replace gsales=gsales/100 if a=="L" | a==""
replace netsales=netsales/100 if a=="L" | a==""
replace relinc=relinc/100 if a=="L" | a==""
replace totinc=totinc/100 if a=="L" | a==""
replace rm=rm/100 if a=="L" | a==""
replace salary=salary/100 if a=="L" | a==""
replace totcost=totcost/100 if a=="L" | a==""
replace pbild=pbild/100 if a=="L" | a==""
replace interest=interest/100 if a=="L" | a==""
replace lease=lease/100 if a=="L" | a==""
replace dep=dep/100 if a=="L" | a==""
replace opprofit=opprofit/100 if a=="L" | a==""
replace unrelinc=unrelinc/100 if a=="L" | a==""
replace tax=tax/100 if a=="L" | a==""
replace netprofit=netprofit/100 if a=="L" | a==""
replace prefdiv=prefdiv/100 if a=="L" | a==""
replace reserves=reserves/100 if a=="L" | a==""
replace expsales=expsales/100 if a=="L" | a==""
replace rmprcnt=rmprcnt/100 if a=="L" | a==""

drop if a=="Y"
*keep gsales netsales totinc pbild opprofit netprofit
rename year t

**keep only 1 observation per bid per year -- in some (few) cases there are more than 1 observation
sort bid enddate
duplicates drop bid t, force
*this will keep the earliest observation from each year

drop if t<1981
compress
sort bid t
save profit, replace

**now ratio
use <NAME OF DATA SET WITH FINANCIAL RATIOS>, clear
replace profr6=profr6/100 if a=="L" | a==""
replace capr3=capr3/100 if a=="L" | a==""

drop if a=="Y"
rename year t

**keep only 1 observation per bid per year -- in some (few) cases there are more than 1 observation
sort bid enddate
duplicates drop bid t, force
*this will keep the earliest observation from each year

drop if t<1981
compress
sort bid t
save ratio, replace

***now merge everything
clear
set mem 1000m

use repay_new, clear
sort bid projcluster tq
merge bid projcluster tq using creditrcvd
tab _merge
rename _merge m_repaycredit
compress

sort bid projcluster tq

fillin bid projcluster tq

egen group=group(bid projcluster)
tsset group tq
tsfill, full

replace creditrcvd=0 if creditrcvd==.
sort bid projcluster tq
gen t=yofd(dofq(tq))
sort bid t

count
compress

merge bid using balancefirstobs
tab _merge
drop _merge sheqty rescap resgen resspecific resint1 nvl faland famach fabuild faother
sort bid t
compress

merge bid t using profit
tab _merge
drop _merge relinc rm salary totcost expsales prefdiv reserves rmprcnt
sort bid t
compress

sort bid
merge bid using clientdata
tab _merge
drop _merge
compress

label values projcluster statecluster
sort bid projcluster tq

count if bid==.
count if tq==.
drop if tq==.
*these are observations where we know the borrower's financial information but nothing else

compress

save newdata3, replace

erase migratemaster.dta
erase irwidenoattr.dta

//Now extract data needed.
use avgallpin180 creditrcvd intrate avgdur t yearofasset assets industry borrcluster mindur maxdur bid tq if t<=2002 using newdata3.dta

*these are data at the bid-projcluster-tq level
*drop data after 2002 because 2003 data likely to be incomplete since data collected in Summer 2003, and data after that only contain scheduled invoices
*but no actual information about what happened.

count

collapse (sum)creditrcvd (mean)avgallpin180 intrate avgdur t yearofasset assets industry borrcluster (min)mindur (max)maxdur, by(bid tq)

count if bid==.

gen bdrtdts=mdy(4,27,1994) if borrcluster==1
replace bdrtdts=mdy(7,5,1994) if borrcluster==2
replace bdrtdts=mdy(8,30,1994) if borrcluster==3
replace bdrtdts=mdy(11,30,1994) if borrcluster==4
replace bdrtdts=mdy(12,21,1994) if borrcluster==5
replace bdrtdts=mdy(11,4,1996) if borrcluster==6
replace bdrtdts=mdy(1,7,1997) if borrcluster==7
replace bdrtdts=mdy(1,24,1997) if borrcluster==8
replace bdrtdts=mdy(4,7,1998) if borrcluster==9
replace bdrtdts=mdy(7,16,1999) if borrcluster==10
replace bdrtdts=mdy(12,5,1997) if borrcluster==11| borrcluster==12

gen bdrtdtq=qofd(bdrtdts)
gen bdrt=(tq>=bdrtdtq)
format bdrtdts %d
format bdrtdtq %tq
drop bdrtdts bdrtdtq

gen assets2=assets^2

replace creditrcvd=creditrcvd/10000000
note creditrcvd: "Credit received, crores"

gen drtdts1=mdy(4,27,1994)
gen drtdts2=mdy(7,5,1994)
gen drtdts3=mdy(8,30,1994)
gen drtdts4=mdy(11,30,1994)
gen drtdts5=mdy(12,21,1994)
gen drtdts6=mdy(11,4,1996)
gen drtdts7=mdy(1,7,1997)
gen drtdts8=mdy(1,24,1997)
gen drtdts9=mdy(4,7,1998)
gen drtdts10=mdy(7,16,1999)
gen drtdts11=mdy(12,5,1997)
gen drtdts12=mdy(12,5,1997)

gen drtdtq1=qofd(drtdts1)
gen drtdtq2=qofd(drtdts2)
gen drtdtq3=qofd(drtdts3)
gen drtdtq4=qofd(drtdts4)
gen drtdtq5=qofd(drtdts5)
gen drtdtq6=qofd(drtdts6)
gen drtdtq7=qofd(drtdts7)
gen drtdtq8=qofd(drtdts8)
gen drtdtq9=qofd(drtdts9)
gen drtdtq10=qofd(drtdts10)
gen drtdtq11=qofd(drtdts11)
gen drtdtq12=qofd(drtdts12)

gen drt1=(tq>=drtdtq1)
replace drt1=. if tq==.
gen drt2=(tq>=drtdtq2)
replace drt2=. if tq==.
gen drt3=(tq>=drtdtq3)
replace drt3=. if tq==.
gen drt4=(tq>=drtdtq4)
replace drt4=. if tq==.
gen drt5=(tq>=drtdtq5)
replace drt5=. if tq==.
gen drt6=(tq>=drtdtq6)
replace drt6=. if tq==.
gen drt7=(tq>=drtdtq7)
replace drt7=. if tq==.
gen drt8=(tq>=drtdtq8)
replace drt8=. if tq==.
gen drt9=(tq>=drtdtq9)
replace drt9=. if tq==.
gen drt10=(tq>=drtdtq10)
replace drt10=. if tq==.
gen drt11=(tq>=drtdtq11)
replace drt11=. if tq==.
gen drt12=(tq>=drtdtq12)
replace drt12=. if tq==.

gen drtall=drt1+drt2+drt3+drt4+drt5+drt6+drt7+drt8+drt9+drt10+drt11+drt12
*drop drt1 drt2 drt3 drt4 drt5 drt6 drt7 drt8 drt9 drt10 drt11 drt12
drop drtdtq1 drtdtq2 drtdtq3 drtdtq4 drtdtq5 drtdtq6 drtdtq7 drtdtq8 drtdtq9 drtdtq10 drtdtq11 drtdtq12
drop drtdts1 drtdts2 drtdts3 drtdts4 drtdts5 drtdts6 drtdts7 drtdts8 drtdts9 drtdts10 drtdts11 drtdts12
label var drtall "Sum(DRT_j)"

gen drtown=.

forvalues x=1/12 {
    display "cluster=`x'"
    replace drtown=drt`x' if borrcluster==`x'
    }
replace drtown=0 if drtown==.

label var drtown "DRT_i"

**now create sumthetaalpha to measure GE effects
sort borrcluster tq
bys borrcluster: egen assets_bc=sum(assets) if t>=1982 & t<=1990
*this uses the assets data only from 82 to 92 to create the sumthetaalpha variable.
replace assets_bc=. if borrcluster==.

sort borrcluster tq
bys borrcluster: replace assets_bc=assets_bc[_n-1] if assets_bc==.

gsort borrcluster -tq
bys borrcluster: replace assets_bc=assets_bc[_n-1] if assets_bc==.

count if assets_bc==.
summ borrcluster if assets_bc==.

forvalues i=1/12 {
    summarize assets_bc if borrcluster==`i'
    global assetsbc`i'=r(mean)
    }

*there are no firms from borrcluster 12 in this dataset
global ctyassets=$assetsbc1+$assetsbc2+$assetsbc3+$assetsbc4+$assetsbc5+$assetsbc6+$assetsbc7+$assetsbc8+$assetsbc9+$assetsbc10+$assetsbc11

gen sta=(drt2*($assetsbc2/$ctyassets))+(drt3*($assetsbc3/$ctyassets))+(drt4*($assetsbc4/$ctyassets))+(drt5*($assetsbc5/$ctyassets))/*
*/          +(drt6*($assetsbc6/$ctyassets))+(drt7*($assetsbc7/$ctyassets))+(drt8*($assetsbc8/$ctyassets))+(drt9*($assetsbc9/$ctyassets)) /*
*/          +(drt10*($assetsbc10/$ctyassets))+(drt11*($assetsbc11/$ctyassets)) if borrcluster==1

replace sta=(drt1*($assetsbc1/$ctyassets))+(drt3*($assetsbc3/$ctyassets))+(drt4*($assetsbc4/$ctyassets))+(drt5*($assetsbc5/$ctyassets))/*
*/          +(drt6*($assetsbc6/$ctyassets))+(drt7*($assetsbc7/$ctyassets))+(drt8*($assetsbc8/$ctyassets))+(drt9*($assetsbc9/$ctyassets)) /*
*/          +(drt10*($assetsbc10/$ctyassets))+(drt11*($assetsbc11/$ctyassets)) if borrcluster==2

replace sta=(drt1*($assetsbc1/$ctyassets))+(drt2*($assetsbc2/$ctyassets))+(drt4*($assetsbc4/$ctyassets))+(drt5*($assetsbc5/$ctyassets))/*
*/          +(drt6*($assetsbc6/$ctyassets))+(drt7*($assetsbc7/$ctyassets))+(drt8*($assetsbc8/$ctyassets))+(drt9*($assetsbc9/$ctyassets)) /*
*/          +(drt10*($assetsbc10/$ctyassets))+(drt11*($assetsbc11/$ctyassets)) if borrcluster==3

replace sta=(drt1*($assetsbc1/$ctyassets))+(drt2*($assetsbc2/$ctyassets))+(drt3*($assetsbc3/$ctyassets))+(drt5*($assetsbc5/$ctyassets))/*
*/          +(drt6*($assetsbc6/$ctyassets))+(drt7*($assetsbc7/$ctyassets))+(drt8*($assetsbc8/$ctyassets))+(drt9*($assetsbc9/$ctyassets)) /*
*/          +(drt10*($assetsbc10/$ctyassets))+(drt11*($assetsbc11/$ctyassets)) if borrcluster==4

replace sta=(drt1*($assetsbc1/$ctyassets))+(drt2*($assetsbc2/$ctyassets))+(drt3*($assetsbc3/$ctyassets))+(drt4*($assetsbc4/$ctyassets))/*
*/          +(drt6*($assetsbc6/$ctyassets))+(drt7*($assetsbc7/$ctyassets))+(drt8*($assetsbc8/$ctyassets))+(drt9*($assetsbc9/$ctyassets)) /*
*/          +(drt10*($assetsbc10/$ctyassets))+(drt11*($assetsbc11/$ctyassets)) if borrcluster==5

replace sta=(drt1*($assetsbc1/$ctyassets))+(drt2*($assetsbc2/$ctyassets))+(drt3*($assetsbc3/$ctyassets))+(drt4*($assetsbc4/$ctyassets))/*
*/          +(drt5*($assetsbc5/$ctyassets))+(drt7*($assetsbc7/$ctyassets))+(drt8*($assetsbc8/$ctyassets))+(drt9*($assetsbc9/$ctyassets)) /*
*/          +(drt10*($assetsbc10/$ctyassets))+(drt11*($assetsbc11/$ctyassets)) if borrcluster==6

replace sta=(drt1*($assetsbc1/$ctyassets))+(drt2*($assetsbc2/$ctyassets))+(drt3*($assetsbc3/$ctyassets))+(drt4*($assetsbc4/$ctyassets))/*
*/          +(drt5*($assetsbc5/$ctyassets))+(drt6*($assetsbc6/$ctyassets))+(drt8*($assetsbc8/$ctyassets))+(drt9*($assetsbc9/$ctyassets)) /*
*/          +(drt10*($assetsbc10/$ctyassets))+(drt11*($assetsbc11/$ctyassets)) if borrcluster==7

replace sta=(drt1*($assetsbc1/$ctyassets))+(drt2*($assetsbc2/$ctyassets))+(drt3*($assetsbc3/$ctyassets))+(drt4*($assetsbc4/$ctyassets))/*
*/          +(drt5*($assetsbc5/$ctyassets))+(drt6*($assetsbc6/$ctyassets))+(drt7*($assetsbc7/$ctyassets))+(drt9*($assetsbc9/$ctyassets)) /*
*/          +(drt10*($assetsbc10/$ctyassets))+(drt11*($assetsbc11/$ctyassets)) if borrcluster==8

replace sta=(drt1*($assetsbc1/$ctyassets))+(drt2*($assetsbc2/$ctyassets))+(drt3*($assetsbc3/$ctyassets))+(drt4*($assetsbc4/$ctyassets))/*
*/          +(drt5*($assetsbc5/$ctyassets))+(drt6*($assetsbc6/$ctyassets))+(drt7*($assetsbc7/$ctyassets))+(drt8*($assetsbc8/$ctyassets)) /*
*/          +(drt10*($assetsbc10/$ctyassets))+(drt11*($assetsbc11/$ctyassets)) if borrcluster==9

replace sta=(drt1*($assetsbc1/$ctyassets))+(drt2*($assetsbc2/$ctyassets))+(drt3*($assetsbc3/$ctyassets))+(drt4*($assetsbc4/$ctyassets))/*
*/          +(drt5*($assetsbc5/$ctyassets))+(drt6*($assetsbc6/$ctyassets))+(drt7*($assetsbc7/$ctyassets))+(drt8*($assetsbc8/$ctyassets)) /*
*/          +(drt9*($assetsbc9/$ctyassets))+(drt11*($assetsbc11/$ctyassets)) if borrcluster==10

replace sta=(drt1*($assetsbc1/$ctyassets))+(drt2*($assetsbc2/$ctyassets))+(drt3*($assetsbc3/$ctyassets))+(drt4*($assetsbc4/$ctyassets))/*
*/          +(drt5*($assetsbc5/$ctyassets))+(drt6*($assetsbc6/$ctyassets))+(drt7*($assetsbc7/$ctyassets))+(drt8*($assetsbc8/$ctyassets)) /*
*/          +(drt9*($assetsbc9/$ctyassets))+(drt10*($assetsbc10/$ctyassets)) if borrcluster==11


count
sort bid tq
save newdataborr1, replace
save newdataborr6, replace

log close
