clear

set more off
**
/*
this file generates the data used in the regressions. In the first part, the files downloaded from prowess are transferred into stata files. 

The prowess files are constructed following the structure of the balance sheet: assets, profits, liabilities. In the first step, only the relevant data items are kept 
many more are in the files downloaded from prowess.
*/


cd E:\papers\sujataanddilip\ecmafinal\prowessdataoriginal

 
insheet using companyinfo.txt, delimiter("|") clear
drop if _n<4

outsheet using companyinfo.csv , delimiter("|")  replace nonames

insheet using companyinfo.csv,  delimiter("|")  clear names
gen bid=_n
sort bid companyname
save companyinfo.dta , replace
erase companyinfo.csv
 


foreach file in infos liability assets income{
forvalues y=1988/2003 {
insheet using `file'`y'.txt, delimiter("|") clear
drop if _n<4

outsheet using `file'`y'h.csv , delimiter("|")  replace nonames


insheet using `file'`y'h.csv,  delimiter("|")  clear names
gen bid=_n
sort bid companyname
* cd "E:\papers\sujataanddilip\prowessnew\"

gen year=`y'
sort bid companyname
merge  bid companyname using companyinfo.dta
tab _merge
drop _merge
sort bid companyname
*check that there are no data if ymfinance_year==.
sum companyname -  bid 
sum companyname -  bid if ymfinance_year ==.
drop if ymfinance_year ==.
save `file'`y', replace

erase "`file'`y'h.csv "
}
}



forvalues y=1988/2003 {
use companyinfo.dta, clear

foreach file in infos liability assets income{


sort bid companyname
merge bid companyname using `file'`y'.dta

tab _merge
drop _merge
}

**********
*********
**********
********
*THIS IS WHERE THE RELEVANT DATA IS KEPT
*keep  companyname bid grossfixedassets landbuilding plantmachinerycomputerselectrica netfixedassets currentassets totalassets land building plantmachinery registeredofficeaddress niccode economicactivity niccode
save allrelevant`y'.dta, replace

}

use allrelevant1988.dta, clear

forvalues y=1989/2003 {
sort bid companyname


append using allrelevant`y'.dta
foreach file in infos liability assets income{

erase  `file'`y'.dta 
}
erase allrelevant`y'.dta

}
sort bid companyname year
drop if year==.
*erase `file'1988.dta 
*erase allrelevant1988.dta
*}

*}
sort year
*by year: sum 
*companyname - bid


*cap log close
*log using creatingregdata.log,  replace


*set mem 500m
gen borrcluster=.
gen state=.
replace state=1  if  strpos(lower(registeredofficeaddress),lower("Andhra Pradesh"))>0
replace state=2 if strpos(lower(registeredofficeaddress),lower("Delhi"))>0 
replace state=3 if strpos(lower(registeredofficeaddress),lower("Gujarat"))>0 
replace state=4 if strpos(lower(registeredofficeaddress),lower("Haryana"))>0 
replace state=5 if   strpos(lower(registeredofficeaddress),lower("Himachal Pradesh"))>0  
replace state=6 if strpos(lower(registeredofficeaddress),lower("Jammu"))>0   |  strpos(lower(registeredofficeaddress),lower("Kashmir"))>0  
replace state=7  if strpos(lower(registeredofficeaddress),lower("Bihar"))>0 | strpos(lower(registeredofficeaddress),lower("Jharkhand"))>0 
***************************NOTE: Jharkhand becamce a state in 2000. What to do about it?
replace state=8  if strpos(lower(registeredofficeaddress),lower("Karnataka"))>0 
replace state=9  if strpos(lower(registeredofficeaddress),lower("Madhya Pradesh"))>0 |  strpos(lower(registeredofficeaddress),lower("Chhattisgarh"))>0 
replace state=10  if strpos(lower(registeredofficeaddress),lower("Maharashtra"))>0 
replace state=11  if strpos(lower(registeredofficeaddress),lower("Pondicher"))>0 | strpos(lower(registeredofficeaddress),lower("Puducherry"))>0 
replace state=12 if strpos(lower(registeredofficeaddress),lower("Rajasthan"))>0  
replace state=13  if strpos(lower(registeredofficeaddress),lower("Tamil Nadu"))>0 
replace state=14 if strpos(lower(registeredofficeaddress),lower("Uttar Pradesh"))>0 |  strpos(lower(registeredofficeaddress),lower("Uttarakhand"))>0
***************************NOTE: Uttarakhand becamce a state in 2000. What to do about it?
replace state=15  if strpos(lower(registeredofficeaddress),lower("West Bengal"))>0 
replace state=16 if strpos(lower(registeredofficeaddress),lower("Kerala"))>0 
replace state=17 if strpos(lower(registeredofficeaddress),lower("Punjab"))>0 
*drop foreign companies
drop if state==18
 
replace state=19 if strpos(lower(registeredofficeaddress),lower("Assam"))>0
replace state=20 if strpos(lower(registeredofficeaddress),lower("Goa"))>0
replace state=21 if  strpos(lower(registeredofficeaddress),lower("Chandigarh"))>0 
******************************************************************************What happened to Chhatisgarh DRT?
replace state=22 if strpos(lower(registeredofficeaddress),lower("Dadra"))>0 |  strpos(lower(registeredofficeaddress),lower("Nagar Haveli"))>0 
replace state=23 if  strpos(lower(registeredofficeaddress),lower("Daman"))>0 |  strpos(lower(registeredofficeaddress),lower("Diu"))>0 
replace state=24 if  strpos(lower(registeredofficeaddress),lower("Orissa"))>0
replace state=25 if  strpos(lower(registeredofficeaddress),lower("Andaman"))>0 | strpos(lower(registeredofficeaddress),lower("Nicobar Islands"))>0
replace state=26 if  strpos(lower(registeredofficeaddress),lower("Meghalaya"))>0 
replace state=27 if strpos(lower(registeredofficeaddress),lower("Manipur"))>0
replace state=28 if   strpos(lower(registeredofficeaddress),lower("Mizoram"))>0 
replace state=29 if  strpos(lower(registeredofficeaddress),lower("Tripura"))>0 
replace state=30 if  strpos(lower(registeredofficeaddress),lower("Arunachal Pradesh"))>0 
replace state=31 if strpos(lower(registeredofficeaddress),lower("Nagaland"))>0
replace state=32 if  strpos(lower(registeredofficeaddress),lower("Lakshadweep"))>0 
replace state=33 if  strpos(lower(registeredofficeaddress),lower("Sikkim"))>0 

       




count if state==.
count if state<.



*15 West Bengal
replace borrcluster=1 if strpos(lower(registeredofficeaddress),lower("West Bengal"))>0 | state==15 | strpos(lower(registeredofficeaddress),lower("Andaman"))>0 | strpos(lower(registeredofficeaddress),lower("Nicobar Islands"))>0
gen bdrtdts=mdy(4,27,1994) if borrcluster==1

*state 2 Delhi
replace borrcluster=2 if strpos(lower(registeredofficeaddress),lower("Delhi"))>0 | state==2
replace bdrtdts=mdy(7,5,1994) if borrcluster==2

*12 Rajasthan 5 Himachal Pradesh    4 Haryana 17 Punjab
replace borrcluster=3 if strpos(lower(registeredofficeaddress),lower("Rajasthan"))>0 | state==12 | strpos(lower(registeredofficeaddress),lower("Himachal Pradesh"))>0 |   state==5| strpos(lower(registeredofficeaddress),lower("Haryana"))>0 |  strpos(lower(registeredofficeaddress),lower("Punjab"))>0 | state==4 | state==17 |  strpos(lower(registeredofficeaddress),lower("Chandigarh"))>0 
replace bdrtdts=mdy(8,30,1994) if borrcluster==3

* 8 Karnataka           1 Andhra Pradesh
replace borrcluster=4 if strpos(lower(registeredofficeaddress),lower("Karnataka"))>0 | state==8 |state==1  | strpos(lower(registeredofficeaddress),lower("Andhra Pradesh"))>0
replace bdrtdts=mdy(11,30,1994) if borrcluster==4

*3 Gujarat
replace borrcluster=5 if strpos(lower(registeredofficeaddress),lower("Gujarat"))>0 |state==3 | strpos(lower(registeredofficeaddress),lower("Dadra"))>0 |  strpos(lower(registeredofficeaddress),lower("Nagar Haveli"))>0 |  strpos(lower(registeredofficeaddress),lower("Daman"))>0 |  strpos(lower(registeredofficeaddress),lower("Diu"))>0 
replace bdrtdts=mdy(12,21,1994) if borrcluster==5

*13 Tamil Nadu | 16 Kerala |  11 Pondicherry    
replace borrcluster=6 if strpos(lower(registeredofficeaddress),lower("Tamil Nadu"))>0 | state==13 | state==16 | state==11 | strpos(lower(registeredofficeaddress),lower("Kerala"))>0 |  strpos(lower(registeredofficeaddress),lower("Pondicherrya"))>0 
replace bdrtdts=mdy(11,4,1996) if borrcluster==6

replace borrcluster=7 if strpos(lower(registeredofficeaddress),lower("Assam"))>0 | strpos(lower(registeredofficeaddress),lower("Meghalaya"))>0 | strpos(lower(registeredofficeaddress),lower("Manipur"))>0 |  strpos(lower(registeredofficeaddress),lower("Mizoram"))>0 |  strpos(lower(registeredofficeaddress),lower("Tripura"))>0 | strpos(lower(registeredofficeaddress),lower("Arunachal Pradesh"))>0 | strpos(lower(registeredofficeaddress),lower("Nagaland"))>0
replace bdrtdts=mdy(1,7,1997) if borrcluster==7

*   7 Jharkhand/Bihar
replace borrcluster=8 if strpos(lower(registeredofficeaddress),lower("Bihar"))>0 | state==7 | strpos(lower(registeredofficeaddress),lower("Orissa"))>0
replace bdrtdts=mdy(1,24,1997) if borrcluster==8

* 9 Madhya Pradesh   14 Uttar Pradesh/Uttaranchal     
replace borrcluster=9 if strpos(lower(registeredofficeaddress),lower("Madhya Pradesh"))>0 | state==9 | state==14 | strpos(lower(registeredofficeaddress),lower("Uttar Pradesh"))>0
replace bdrtdts=mdy(4,7,1998) if borrcluster==9

* 10 Maharashtra         
replace borrcluster=10 if strpos(lower(registeredofficeaddress),lower("Maharashtra"))>0 | state==10 | strpos(lower(registeredofficeaddress),lower("Goa"))>0
replace bdrtdts=mdy(7,16,1999) if borrcluster==10

replace borrcluster=11 if strpos(lower(registeredofficeaddress),lower("Lakshadweep"))>0 
replace borrcluster=12 if strpos(lower(registeredofficeaddress),lower("Sikkim"))>0 
replace bdrtdts=mdy(12,5,1997) if borrcluster==11| borrcluster==12

**drop all financial firms, central- and state-govt owned enterprises and development financial instns
*drop if industryname=="Banking services" | industryname=="Misc. financial services" | industryname=="" | industryname=="Non-banking financial cos. (NBFCs)" | industryname=="Other financial institutions" | industryname=="Securities and stock traders" | industryname=="Housing finance services" 
drop if strpos(ownershipgroup , "Central")>0 |strpos( ownershipgroup , "State")>0
*drop if strpos(industryname , "india development")>0

count 
count if borrcluster<.
*sort compname 
count if registeredofficeaddress==""


gen finyear=ymfinance_year
tostring finyear, replace
gen accountdate=mofd( date(finyear),"YM")
gen yyyy=year 
gen sep=09
 

gen drtdate=mofd(bdrtdts)

 

 
rename yyyy t

gen nic2h=nicc
tostring nic2h, replace
gen zero="0"
egen nic2hh=concat(zero nic2h)
replace nic2h=nic2hh if nicc<10000
gen nic2digit=substr(nic2h, 1, 2)
drop nic2hh zero nic2h
*drop rocregistrationnumber yearofincorporation ownershipgroupcode ownershipgroup scripisincode nsescripcode bsescripcode bsedematcode bseabbrevforcompanynames bselistinggroup registeredofficeaddress registeredofficepincode registeredofficephonenumber registeredofficefaxnumber registeredofficeemailaddress headofficeaddress headofficepincode headofficetelephonenumber  headofficefaxnumber headofficeemailaddress  companywebsiteaddress registrarname registrarofficeaddress registrarofficepincode registrarofficephonenumber registrarofficefaxnumber registrarofficeemailaddress registrarwebsiteaddress

compress

sort borrcluster t
compress
  
 
 
sort t



/*We are now merging the data with a dataset which contains the price index and the inflation rate. 
The price index was downloaded from the RBI homepage  while inflation was computed.
*/
set more off
cd "E:\papers\sujataanddilip\ecmafinal"

merge t using   "inflwpi2.dta"
drop _merge
  
tsset bid t
 

sort bid t

*This is Prowess definition of short term borrowing
gen shortterm = commercialpaper +  shorttermbankborrowings 


*This is Prowess definition of long term borrowing

 gen ltermbor=totalborrowing -  shortterm 

/*
New long term borrowing is retrieved using the following data items whenever available: 
A: Cash flow from long term borrowing
B: Cash flow from total borrowin net of short term borrowing
C: Current fraction of long term borrowing (lagged, on time period ago) (the part of long term borrowing that will be short term next period) 
together with the total stock of current borrowing
*/







sort bid t
 

*step A:
gen newlterm=cf_l if cf_l>0
 
/*For steps A and B, we can only be sure that the data exist as missing data for cash flows is replaced with 0 in the Prowess database. 
Hence the qualifier that  cf_l and cf_t must be positive.*/

*step B, throughout we make use of the observation that new long term borrowing must be positive:
replace newlterm=max(0,( cf_t*(month/12)-shortterm )*(12/month)) if newlterm==. & cf_t>0

 
*Step C-1: The constructed variable oldlterm tells us how much of lagged long term borrowing will continue to be long term
gen oldlterm= (L.lterm - L.currentpor*(month/12) )

*Step C-1: The part of new long term borrowing that is because of new long term borrowing
replace newlterm=lterm - oldlterm  if L.currentpor>0  & (newlterm==.  |  ( newlterm==0 & cf_t*(month/12)-shortterm )*(12/month)<0 )
 
 
/*Step D: Various additional filters. */

 

gen new1=cf_l if cf_l >0  
gen new2= ( cf_t*(month/12)-shortterm )*(12/month)  if cf_t>0
gen new3=lterm - oldlterm  if L.currentpor>0  
 

gen goodnew1=cf_l if cf_l >0  & cf_l <newlterm
gen goodnew2= ( cf_t*(month/12)-shortterm )*(12/month)  if ( cf_t*(month/12)-shortterm )*(12/month)  >0 & ( cf_t*(month/12)-shortterm )*(12/month)  <newlterm
gen goodnew3=lterm - oldlterm  if L.currentpor>0  &  lterm - oldlterm  >0
egen goodmean=rowmean( goodnew1  goodnew2  goodnew3)
replace newlterm=goodmean if  (newlterm<=0 | newlterm>ltermbo )  & goodmean <.



replace newlterm=min(new1, new2, new3) if newlterm>ltermbo & min(new1, new2, new3)  <.& goodmean <. &min(new1, new2, new3) >0
replace newlterm=ltermbo  if  newlterm>ltermbo  & newlterm<.
replace newlterm=0 if  newlterm<0


 *******************this normalizes the observations to a 12 month accounting year
 replace newlterm =(month/12)*newlterm

 
foreach y of varlist   total_assets -  pbt  newlterm  ltermbor-goodmean{

**********************************************************Deflate the data using the data in inflation. Priceindex is based
********on industrial worker price index. Use 2002 as benchmark
*replace `y'=`y'*(priceindex/482) if priceindex<.
      


*******************This is for the wholesale priceindex


replace `y'=`y'*(priceindex/166.8) if priceindex<.


  }




 
*A firm has DRT if it is covered by DRT at the accounting date. 
gen drtown=0 
replace drtown=1 if drtdate<=accountdate & accountdate<. & drtdate<.



*switch DRT off in 1995 because of the Delhi HC ruling.
replace drtown=0 if t==1996


sort bid t
*This is the asset definition of tangible assets which gives us the asset size over which we use the exposure to DRT
gen  assets=(totalasset-intangibleassets)
 
local  drtlogass"DRT*logTang.Ass."


gen drtyear=yofd(bdrtdts)
sum drtyear
gen drttime=t-drtyear
rename year yearold
gen year=t
 
 

label var drtown "DRT"

 
 
egen tag=tag(bid t)
 
keep if tag==1
drop if bid==.
*these dropped observations are all missing values


tsset bid t


*this generates the pre-determined asset classes
gen lassetsh=assets if  t==1990
bys bid: egen Lassets=max(lassetsh)
drop lassetsh

count if Lassets~=.
keep if Lassets<.
label var Lassets "Tang.Ass."

gen assetsh=assets
replace assetsh=1 if assets<=1
gen logassets=log(assetsh)
drop assetsh

gen logassetsh=logassets if  t==1990
bys bid: egen Llogassets=max(logassetsh)
drop logassetsh


display "interaction terms"

gen drtsize=drtown*Lassets
label var drtsize "DRT*Tang.Ass."
gen drtlogsize=drtown*Llogassets

label var drtlogsize "DRT*Lag(TangAss)"

 


      
     *make asset size classes on the basis of 1990 data alone -- since that's the data that we carry throughout.
     display "asset size classes"
     display "first, quartiles"
     gen quart1=.
     gen quart2=.
     gen quart3=.
     gen quart4=.

     summarize Lassets if t==1990, detail
     xtile quart=Lassets if t==1990, nq(4)
     bys bid: egen x=max(quart)
     drop quart
     rename x quart
     replace quart1=(quart==1)
     replace quart1=. if Lassets==. 
     replace quart2=(quart==2)
     replace quart2=. if Lassets==. 
     replace quart3=(quart==3)
     replace quart3=. if Lassets==. 
     replace quart4=(quart==4)
     replace quart4=. if Lassets==. 

     summarize Lassets if quart1==1 & t==1990
     summarize Lassets if quart2==1 & t==1990
     summarize Lassets if quart3==1 & t==1990
     summarize Lassets if quart4==1 & t==1990

     label var quart1 "Quartile 1"
     label var quart2 "Quartile 2"
     label var quart3 "Quartile 3"
     label var quart4 "Quartile 4"  
   
   
 
     display "interaction terms"


     gen drtquart1=drtown*quart1
     gen drtquart2=drtown*quart2
     gen drtquart3=drtown*quart3
     gen drtquart4=drtown*quart4
     label var drtquart1 "Q1xDRT_i"
     label var drtquart2 "Q2xDRT_i"
     label var drtquart3 "Q3xDRT_i"
     label var drtquart4 "Q4xDRT_i"
      
     display "generating year dummies..."
     foreach n of numlist 1990/2004 {
     gen t`n'=(t==`n')
     replace t`n'=. if t==.
}

display "generating quartile year dummies"
     foreach n of numlist 1990/2004 {
gen tquart1`n'=t`n'*quart1
gen tquart2`n'=t`n'*quart2
gen tquart3`n'=t`n'*quart3
gen tquart4`n'=t`n'*quart4
}

     display "generating state dummies..."
     foreach i of numlist 1/33 {
     gen state`i'=1 if `i'==state
     replace state`i'=0 if state`i'==.
}




     display "generating state x year dummies..."
     foreach i of numlist 1/33 {
     foreach n of numlist 1990/2004 {
     gen state`i't`n'= state`i'*t`n'

     }
     }


     display "generating state x quart x year dummies..."
     foreach i of numlist 1/33 {
     foreach n of numlist 1990/2004 {
    
gen q1state`i't`n'=state`i't`n'*quart1
gen q2state`i't`n'=state`i't`n'*quart2

gen q3state`i't`n'=state`i't`n'*quart3
gen q4state`i't`n'=state`i't`n'*quart4

     }
     }




  display "generating statetrend dummies..."
     foreach i of numlist 1/33 {
     gen statetrend`i'= state`i'*(t - 1989)
     }
      display "generating statetrend dummies x size..."
     foreach i of numlist 1/33 {
     gen statetrendsize`i'= Lassets*state`i'*(t - 1989)
     }


 display "generating state x quarter dummies..."



foreach i of numlist 1/33 {
     gen state`i'q1= quart1*state`i'*(t - 1989)
     gen state`i'q2= quart2*state`i'*(t - 1989)
     gen state`i'q3= quart3*state`i'*(t - 1989)
     gen state`i'q4= quart4*state`i'*(t - 1989)

     }




     display "generating year x quartile dummies..."  
     foreach n of numlist 1990/2004 {
     gen t`n'quart1=t`n'*quart1
     gen t`n'quart2=t`n'*quart2
     gen t`n'quart3=t`n'*quart3
     gen t`n'quart4=t`n'*quart4
     }


 
     display "generating year x size dummies..."
     foreach n of numlist 1990/2004 {
     gen t`n'size=t`n'*Lassets
     }
     
 display "generating year x size dummies..."
     foreach n of numlist 1990/2004 {
     gen tsq`n'size=t`n'*Lassets*Lassets
     }
     

destring nic2digit, replace
     display "generating nic2digit dummies..."
     foreach i of numlist 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 /*
     */ 40 45 51 52 55 60 61 62 63 64 65 67 70 71 72 73 74 80 85 91 92 97 98 {
     gen nic2dummy`i'=1 if `i'==nic2digit
     replace nic2dummy`i'=0 if nic2dummy`i'==.
     label var nic2dummy`i' "NIC2digit`i'"
}


egen statet=group(state t)
egen stateind=group(state nic2digit)
   

    
    display "**** first with just year dummies as controls ****"
    display "obs in regressions:"
    cap drop tag
    qui gen tag=1 if Lassets~=. & drtown~=. & nic2digit~=. & borrcluster~=.

  
    sort bid
    by bid: egen maxdrt=max(drtown)
    by bid: egen mindrt=min(drtown)
    sum maxdrt mindrt
    count if maxdrt==mindrt
    gen fetag=0 if maxdrt==mindrt
    replace fetag=1 if fetag==.
    tab fetag
    
    bys bid: egen sd=sd(drtown)
    gen sdtag=(sd~=0 & sd~=.)
    tab sdtag
    
    compare fetag sdtag
    
    **Then run borrower FE regressions only on obs where fetag==1
gen salaries=compensationtoemployees


sort year state 
merge year state using  "statelevelinfor.dta"

forvalues m =1/15 {
gen itlog`m'st=log(it`m'st)
}

tab _merge
drop _merge




sort bid
by bid: egen drtyears=total(drtown)
sort bid

**********This generate data used in the pre-trend regressions
gen drtallyears=drtyears

gen pretrendsize=drtyears*Lassets*t

gen preq1=drtallyear*quart1
gen preq2=drtallyear*quart2
gen preq3=drtallyear*quart3
gen preq4=drtallyear*quart4

gen early=1 if drtallyears>=5 & drtallyears<.
replace early=0 if drtallyears<5
gen preq1trend=drtallyear*quart1*t
gen preq2trend=drtallyear*quart2*t
gen preq3trend=drtallyear*quart3*t
gen preq4trend=drtallyear*quart4*t

gen earlytrend1=early*quart1*t
gen earlytrend2=early*quart2*t

gen earlytrend3=early*quart3*t

gen earlytrend4=early*quart4*t

gen earlysizetrend=early*Lassets*t
gen sizetrend=Lassets*t

gen group1drt=drtown
gen group2drt=drtown if borrcluster>5
replace group2drt=0 if borrcluster<=5

set matsize 1200

set more off
*We are using the data item plants and machinery as our asset measure
replace assets= plantmachinerycomputerselectrica
label var assets "PlaMa" 

sort bid t
gen intpay= interestpaid/((totalborr ))
sum intpay if t>1993 & Lassets<., det
replace intpay=. if  intpay>5
replace intpay=intpay*100

replace intpay=intpay-infl*100
sum intp* infl

label var drtsize    "DRT*Tang.Ass."





gen  borrowings   =  newlterm 


drop borrowingsfromcorporatebodies borrowingsfrompromotersdirectors

label var borrowings "borr."
*gen  borrowings   =  totbo
sum    pbdt  
  gen pbdt=pbdta*month/12


 
estimates clear
set more off
set matsize 5000
 
keep if Lassets<.
*drop if t<=1987
sum t, detail

 
 *our regressions run from 92 to 03
gen firstregressionsyear=1992
gen lastregressionsyear=2003    
 


**************************************PIECEWISELINEAR EFFECTS
 
estimates clear

cd "E:\papers\sujataanddilip\ecmafinal"


save dataprowess.dta, replace

 