******************This paper generates columns 1-4 for the table called "Effect of DRT on credit: bank vs. firms"
clear
set more off



cd "E:\papers\sujataanddilip\ecmafinal"


use dataprowess.dta

estimates clear
foreach firstyear in  1990{
foreach i  of numlist  1 4 {


set more off
 

 foreach y of varlist borrowing {

xtreg `y'       drtown t1990- t2004   statetrend1- statetrend33    if  t>=firstregressionsyear &t<=lastregressionsyear &quart==`i', fe cluster(state)
estadd scalar numberofgroups = e(N_g) 
estadd scalar quart=`i'
eststo 
  xtreg `y'     drtown1  drtown2  drtown3  t1990- t2004  statetrend1- statetrend33   if   t>=firstregressionsyear &t<=lastregressionsyear &quart==`i', fe cluster(state)
estadd scalar numberofgroups = e(N_g) 
estadd scalar quart=`i'
 eststo
}
}
}


label var drtown1 "DRT year =1"
label var drtown2 "DRT year =2"
label var drtown3 "DRT year $\ge $3"
label var drtown "DRT"

 
esttab  * using quartiledynamics.csv , star(* 0.10 ** 0.05 *** 0.01)  label /*
   */ title(Differential effect of DRT on firms of different asset quartile. \label{t2a}) /*
   */ addnote("Standard errors are clustered at the state- level.") replace  /*
   */  keep(drtown*  ) stats(quart numberofgroups r2 N , labels("quartile" "number of firms" ) ) /*
 */indicate("YearDummy =  t1995 t1996 "    "Statetrend = statetrend1 statetrend7  statetrend8  "  )   /*
 */postfoot(\multicolumn{@span}{l}{\ {\footnotesize  Standard errors cluster at state level.  \textit{t} statistics in parentheses. \sym{*} \(p<0.10\), \sym{**} \(p<0.05\), \sym{***} \(p<0.01\)} } \\ \multicolumn{@span}{l}{\ \input{notesquartdyn.txt} }\end{tabular}\end{table})  


