clear
set more off
set matsize 1500
set mem 250m
 
cap log close
log using tablesbank.log, replace

//This do file creates the results in Table XI and Columns 4 and 5 of Table XV.

use f:\budesktopbackup\data\drtge\intrate\newdataborr1_disb
*gen state=newclstate
egen stateind=group(state industry)
gen lnintrate=log(intrate)
sum lnintrate 

gen ddtq129=(ddtq==129)
gen ddtq130=(ddtq==130)
gen ddtq131=(ddtq==131)
gen ddtq132=(ddtq==132)
gen ddtq133=(ddtq==133)
gen ddtq134=(ddtq==134)
gen ddtq135=(ddtq==135)
gen ddtq136=(ddtq==136)
gen ddtq137=(ddtq==137)
gen ddtq138=(ddtq==138)
gen ddtq139=(ddtq==139)
gen ddtq140=(ddtq==140)
gen ddtq141=(ddtq==141)
gen ddtq142=(ddtq==142)
gen ddtq143=(ddtq==143)
gen ddtq144=(ddtq==144)
gen ddtq145=(ddtq==145)
gen ddtq146=(ddtq==146)
gen ddtq147=(ddtq==147)
gen ddtq148=(ddtq==148)
gen ddtq149=(ddtq==149)
gen ddtq150=(ddtq==150)
gen ddtq151=(ddtq==151)
gen ddtq152=(ddtq==152)
gen ddtq153=(ddtq==153)
gen ddtq154=(ddtq==154)
gen ddtq155=(ddtq==155)
gen ddtq156=(ddtq==156)
gen ddtq157=(ddtq==157)
gen ddtq158=(ddtq==158)
gen ddtq159=(ddtq==159)
gen ddtq160=(ddtq==160)
gen ddtq161=(ddtq==161)
gen ddtq162=(ddtq==162)
gen ddtq163=(ddtq==163)
gen ddtq164=(ddtq==164)
gen ddtq165=(ddtq==165)
gen ddtq166=(ddtq==166)
gen ddtq167=(ddtq==167)
gen ddtq168=(ddtq==168)
gen ddtq169=(ddtq==169)
gen ddtq170=(ddtq==170)
gen ddtq171=(ddtq==171)

xtset bid

**Use loans with at least 8 years maturity period.
keep if tag92==1 & tag8==1
gen bdrtdts=mdy(4,27,1994) if borrcluster==1
replace bdrtdts=mdy(7,5,1994) if borrcluster==2
replace bdrtdts=mdy(8,30,1994) if borrcluster==3
replace bdrtdts=mdy(11,30,1994) if borrcluster==4
replace bdrtdts=mdy(12,21,1994) if borrcluster==5
replace bdrtdts=mdy(11,4,1996) if borrcluster==6
replace bdrtdts=mdy(1,7,1997) if borrcluster==7
replace bdrtdts=mdy(1,24,1997) if borrcluster==8
replace bdrtdts=mdy(4,7,1998) if borrcluster==9
replace bdrtdts=mdy(7,16,1999) if borrcluster==10
replace bdrtdts=mdy(12,5,1997) if borrcluster==11| borrcluster==12

gen drtquart=qofd(bdrtdts)
format drtquart %tq

gen date=ddtq 
format date %tq
order date 
gen year=yofd(dofq(date))
sort year state
merge year state using <NAME OF DATASET WITH STATE-LEVEL INFORMATION.dta>
tab _merge

gen distance=max(date - drtquart ,0)
gen early=1 if drtquart<=140
summ distance
 
drop drt1-drtall
gen drtown1=1 if distance>0 & distance<=4
gen drtown2=1 if distance>4 & distance<=8
gen drtown3=1 if distance>8 

replace drtown1=0 if drtown1==.
replace drtown2=0 if drtown2==.
replace drtown3=0 if drtown3==.

xi i.distance, prefix(DRT)

xi i.state*ddtq , prefix(tren)

gen intpay=.
label var intpay "intrate"
label var intrate "intrate"
label var drtown1 "DRT year =1"
label var drtown2 "DRT year =2"
label var drtown3 "DRT year $\ge $3"
label var drtown "DRT"

//These lines will give the results in Table XI.
xtreg intrate drtown ddtq129-ddtq171, fe cluster(state)
xtreg intrate drtown creditrcvd_disb durdays ddtq129-ddtq171, fe cluster(state)
xi: xtreg intrate drtown ddtq129-ddtq171 i.borrcluster*ddtq, fe cluster(state)
xi: xtreg intrate drtown creditrcvd_disb durdays ddtq129-ddtq171 i.borrcluster*ddtq, fe cluster(state)
xi3: xtreg intrate drtown creditrcvd_disb durdays ddtq129-ddtq171 i.borrcluster*ddtq, fe cluster(state)
xi3: xtreg intrate drtown i.drtown*assets creditrcvd_disb durdays i.ddtq*assets ddtq129-ddtq171, fe cluster(state)
xi3: xtreg intrate drtown i.drtown*assets i.ddtq*assets i.borrcluster*ddtq*assets i.borrcluster*ddtq ddtq129-ddtq171, fe cluster(state)
xi3: xtreg intrate drtown i.drtown*assets creditrcvd_disb durdays i.ddtq*assets i.borrcluster*ddtq*assets i.borrcluster*ddtq ddtq129-ddtq171, fe cluster(state)

//These lines will give the results in Columns 4 and 5 of Table XV. 

xtreg intrate drtown1 drtown2 drtown3 creditrcvd_disb durdays tren* ddtq129-ddtq171, fe cluster(state)
estadd scalar numberofgroups = e(N_g) 
eststo

xtreg intrate drtown1 drtown2 drtown3 creditrcvd_disb durdays tren* it1st-it4st it6st-it9st it11st -it14st ddtq129-ddtq171, fe cluster(state)
estadd scalar numberofgroups = e(N_g) 
eststo

estimates clear


//The code below generates Table XVII.
clear
cap clear matrix

use newdataborr6, clear
drop if bid==.

tsset bid tq

gen Lassets=assets
label var Lassets "assets"

*make asset size classes on the basis of 1990 data alone -- since that's the data that we carry throughout.
display "asset size classes"
display "first, quartiles"
gen quart1=.
gen quart2=.
gen quart3=.
gen quart4=.

summarize Lassets if t==1990, detail
xtile quart=Lassets if t==1990, nq(4)
bys bid: egen x=max(quart)
drop quart
rename x quart
replace quart1=(quart==1)
replace quart1=. if Lassets==. 
replace quart2=(quart==2)
replace quart2=. if Lassets==. 
replace quart3=(quart==3)
replace quart3=. if Lassets==. 
replace quart4=(quart==4)
replace quart4=. if Lassets==. 

summarize Lassets if quart1==1 & t==1990
summarize Lassets if quart2==1 & t==1990
summarize Lassets if quart3==1 & t==1990
summarize Lassets if quart4==1 & t==1990

label var quart1 "Quartile 1"
label var quart2 "Quartile 2"
label var quart3 "Quartile 3"
label var quart4 "Quartile 4"  

display "next, above the median = large"
gen large=.

summarize Lassets if t==1990, detail
xtile med=Lassets if t==1990, nq(2)
bys bid: egen x=max(med)
replace large=(x==2)
replace large=. if Lassets==.
drop x med

bys large: summarize Lassets if t==1990
display "i am here"

gen small=(large==0)
label var small "Small"
label var large "Large"

*dropping after making lagged values ==> get 1 extra year of obs, potentially
drop if t<1991
drop if t>2002
**dropping t>2002 obs doesn't change anything because we only took obs with t<=2002 in variants.do

sort bid tq
egen bidtag=tag(bid)
keep if bidtag==1
keep bid Lassets large quart1 quart2 quart3 quart4
summarize
save bidsize, replace

****now use other dataset
use <NAME OF DATA SET THAT CONTAINS REPAYMENT INFORMATION>, clear
drop _merge
sort loanid
merge loanid using weirdity129
tab _merge

display "Note from Maharukh"
***Note from Maharukh's e-mail that in the client's profit&loss statement and balancesheet, variable "amt_type" (called "a")
*in grandmaster.dta) is the unit in which the numbers are measured. if a="C" then measured in crores, if a="L" or missing
*then measured in lakhs. here a is in numbers. based on comparisons of magnitudes with the original data, infer that a=1
*is crores, and a=2 or missing or 3 is lakhs."

*matters for assets and income data. here only income.
generate newtotinc=totinc*100 if a==1
replace newtotinc=totinc if (a==2|a==3|a==.)

gen rsamount=amount/1000000
gen lrsamount=log(rsamount)

gen sanctq=qofd(sancdt)
gen sanctq2=sanctq^2
gen sancage=tq-sanctq

gen mattime=matdt-sancdt
replace mattime=. if matdt<sancdt

gen maskloanid=loanid
gen maskbid=bid

**drop all tq's before 118 because there are too few obs and they cause singular covariance matrices.
drop if tq<=118
drop if tq==.

collapse (mean) Outlate129=Outlate129 newtotinc=newtotinc sancstate=sancstate clstate=clstate mattime=mattime ngrindcode=ngrindcode sanctq=sanctq sanctq2=sanctq2 drtdt=drtdt amount=amount lrsamount=lrsamount sancdt=sancdt bdrtdts=bdrtdts (min) allpin180=allpin180, by(bid `var')
display _N 
save repayment_bid_`var', replace

gen bdrtdtq=qofd(bdrtdts)
format %tq bdrtdtq
gen bdrtdt=yofd(bdrtdts)
format %ty bdrtdt

gen cldrt=1 if `var'>=bdrtd`var' & sancdt<bdrtdts
replace cldrt=0 if `var'<bdrtd`var' & sancdt<bdrtdts

set matsize 1000
egen newx=group(clstate t)
egen z=group(clstate ngrindcode)

****Categories of payment behavior

xtile amtnq=amount, nq(10)
egen newz=group(sancstate amtnq)

xtile amtnq5=amount, nq(5)

xtile outnq=Outlate129, nq(10)

gen taum2=mdy(6,24,1991)

**GETTING RID OF OUTLIERS
xtile nout=Outlate129, nq(100)
gen usetag=1 if nout<94 & sancdt<tau

replace Outlate129=Outlate129/1000000
gen cldrtOutlate129=cldrt*Outlate129

**merge in bidsize.dta
*drop _merge
sort bid
merge bid using bidsize
tab _merge

**Now repayment behavior tables require creating an additional interaction
gen cldrtLassets=Lassets*cldrt
gen largecldrt=large*cldrt
gen largeO=large*Outlate129
gen largeOcldrt=largeO*cldrt

gen OLassets=Outlate129*Lassets
gen cldrtOLassets=cldrt*Outlate129*Lassets

**Now label the variables
label var cldrt "DRT" 
label var Outlate129 "Overdues"
label var cldrtOutlate129 "DRT x Overdues"
label var cldrtLassets "DRT x Assets"
label var largecldrt "Large x DRT"
label var largeO "Large x Overdues"
label var largeOcldrt "Large x Overdues x DRT"
label var allpin180 "Probability of timely repayment"
label var OLassets "Overdues x Assets"
label var cldrtOLassets "DRT x Overdues x Assets"

xtile xct = Lassets if newtotinc~=. & large~=. & lrsamount~=. & ngrindcode~=. & Outlate129~=., nq(100)
summ Lassets if xct<=25
summ Lassets if xct>25 & xct<=50
summ Lassets if xct>50 & xct<=75
summ Lassets if xct>75 & xct<=100

summ Outlate129 if xct<=25
summ Outlate129 if xct>25 & xct<=50
summ Outlate129 if xct>50 & xct<=75
summ Outlate129 if xct>75 & xct<=100

bys bid: egen sum0=total(cldrt)
bys bid: gen clmulttag=cond(sum0<_N & sum0>0, "both 0 & 1", "only 0") if sum0<_N
bys bid: replace clmulttag=cond(sum0==_N, "only 1", clmulttag) if clmulttag==""

drop sum0

summ cldrt, detail
summ cldrtOutlate129, detail
summ cldrtOLassets, detail

bys cldrt: summ allpin180

************FE regressions
xi: areg allpin180 Outlate129 cldrt cldrtOutlate129 lrsamount mattime sanctq sanctq2 i.t if nout<94 , absorb(bid) cluster(clstate)
estimates store RFG1

xi: areg allpin180 Outlate129 cldrt cldrtOutlate129 lrsamount mattime newtotinc sanctq sanctq2 i.t if nout<94 , absorb(bid) cluster(clstate)
estimates store RFG2

xi: areg allpin180 Outlate129 cldrt cldrtOutlate129 OLassets cldrtLassets cldrtOLassets lrsamount mattime newtotinc sanctq sanctq2 i.t if nout<94 , absorb(bid) cluster(clstate)
estimates store RFG3

xi: areg allpin180 Outlate129 cldrt cldrtOutlate129 OLassets cldrtLassets cldrtOLassets newtotinc lrsamount mattime sanctq sanctq2 i.t*Lassets if nout<94 , absorb(bid) cluster(clstate)
estimates store RFG4

log close
